/*
	Examples altered from http://obeybrew.com
*/

#include "huc.h"

#incspr(bonk,"bonkwalk.pcx",0,0,2,8);
#incpal(bonkpal,"bonkwalk.pcx");

#incbin(bonk_map, "bonk_BAT.bin");
#incbin(bonk_bg, "bonk_DATA.bin");
#incbin(bonk_pal, "bonk_PAL.bin");

void spr_make(int spriteno, int spritex, int spritey, int spritepattern, int ctrl1, int ctrl2, int sprpal, int sprpri)
{
	spr_set(spriteno);
	spr_x(spritex);
	spr_y(spritey);
	spr_pattern(spritepattern);
	spr_ctrl(ctrl1,ctrl2);
	spr_pal(sprpal);
	spr_pri(sprpri);
}

void pause()
{
	while(1)
	{
		vsync();
		if (joytrg(0) & JOY_STRT) 
			return;
	}
}

void main()
{
	int held, pressed, bonkx = 104;
	char frames = 0, anim_frame = 0;
	int colswap = 0;

	set_screen_size(SCR_SIZE_32x32);

	load_palette(16, bonkpal, 1);
	set_color(256, 0);
	load_vram(0x5000, bonk, 0x400);

	load_background(bonk_bg, bonk_pal, bonk_map, 40, 30);

	init_satb();
	spr_make(0, 104, 176, 0x5100, FLIP_MAS|SIZE_MAS, NO_FLIP|SZ_32x32, 0, 1);
	satb_update();

	while(1)
	{
		vsync();
		held = joy(0);
		pressed = joytrg(0);
		if (held & JOY_LEFT)
		{
			frames++;
			spr_ctrl(FLIP_X_MASK,FLIP_X);
			if (bonkx > -8) 
				bonkx--;
		}
		if (held & JOY_RGHT)
		{
			frames++;
			spr_ctrl(FLIP_X_MASK,NO_FLIP_X);
			if (bonkx < 232) 
				bonkx++;
		}
		if (pressed & JOY_STRT)
		{
			pause();
		}
		spr_x(bonkx);

		if (frames > 4)
		{
			frames = 0;
			anim_frame++;
			if (anim_frame > 5) 
				anim_frame = 0;
			if (anim_frame == 0) 
				spr_pattern(0x5100);
			if (anim_frame == 1) 
				spr_pattern(0x5200);
			if (anim_frame == 2) 
				spr_pattern(0x5300);
			if (anim_frame == 3) 
				spr_pattern(0x5200);
			if (anim_frame == 4) 
				spr_pattern(0x5100);
			if (anim_frame == 5) 
				spr_pattern(0x5000);
		}
		satb_update();

		if(colswap == 60)
		{
			SwapPalette(6, 4);
			SwapPalette(7, 8);
			
			colswap = 0;
		}
		colswap++;
		scroll(0, bonkx, 0, 0, 76, 0xC0);
		scroll(1, 2*bonkx, 76, 76, 160, 0xC0);
		scroll(2, 3*bonkx, 160, 160, 208, 0xC0);
		scroll(3, 4*bonkx, 208, 208, 240, 0xC0);
	}
}

void SwapPalette(int pal, int index)
{
	int pos;
	int tmpcol1 = 0;
	int tmpcol2 = 0;
	int tmpcol3 = 0;
	int tmpcol4 = 0;
	
	pos = index+pal*16;
	tmpcol1 = get_color(pos);
	tmpcol2 = get_color(pos+1);
	tmpcol3 = get_color(pos+2);
	tmpcol4 = get_color(pos+3);
		
	set_color(pos, tmpcol4);
	set_color(pos+1, tmpcol1);
	set_color(pos+2, tmpcol2);
	set_color(pos+3, tmpcol3);
}
